
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>性能测试：自建数据库与RDS性能对比SQL Server案例排查分析 / iVAN</title>

    <meta name="description" content="性能测试：自建数据库与RDS性能对比SQL Server案例排查分析 近期经常遇到用户将自建数据库与RDS进行对比,简单的对比结果是自建库比RDS实例查询快.我们这里来看看一个实例,有一家物流公司,刚开始使用RDS SQL Server数据库,发现通过ECS访问RDS实例,执行语句需要60s左右,但是访问ECS本地自建库只需要2-3s.那么RDS是否是真的不如自建数据库呢? 接下来,我们来探讨对比自建库和RDS的正确姿势,如何公平地对比自建库和RDS的性能. 对比自建库和RDS的语句执行性能,下面这些因素必须都考虑到: 1. 可用区和网络链路. 可用区.网络链路的">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">性能测试：自建数据库与RDS性能对比SQL Server案例排查分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>近期经常遇到用户将自建数据库与RDS进行对比，简单的对比结果是自建库比RDS实例查询快。我们这里来看看一个实例，有一家物流公司，刚开始使用RDS SQL Server数据库，发现通过ECS访问RDS实例，执行语句需要60s左右，但是访问ECS本地自建库只需要2-3s。那么RDS是否是真的不如自建数据库呢？ 接下来，我们来探讨对比自建库和RDS的正确姿势，如何公平地对比自建库和RDS的性能。</p>
<p>对比自建库和RDS的语句执行性能，下面这些因素必须都考虑到：<br />
<h3>1. 可用区和网络链路。</h3>
<p>可用区、网络链路的分析参考性能测试：自建数据库对比RDS中应当注意的地方即可，这篇文章做了深刻的分析。如果需要验证网络因素，可以在RDS中开启profiler， 并且同时在客户端抓取网络包，对比RDS中执行结束的时间以及网络包中返回结果的时间， 时间差异较大，说明网络传输有延迟。</p>
<p>针对RDS SQL Server 2012实例，可以开启SQL Server Profiler， 抓取RPC:Completed, SQL:StmtStarting, SQL:StmtCompleted, SQL:BatchStarting和SQL:BatchCompleted这几个事件。 </p>
<p>针对RDS SQL Server 2008 R2实例，暂不支持开启SQL Server Profiler， 可以通过下面语句查询近期执行的语句，及其start_time和total_elapased_time 。total_elapased_time指请求到达SQL Server后执行该语句总共消耗的时间（单位ms）。</p>
<h3>2. 实例参数配置。</h3>
<p>MySQL实例需要关注的参数比较多，详细的分析和描述参考性能测试：自建数据库对比RDS中应当注意的地方；<br />SQL Server实例需要关注的参数主要有fill factor (%)，max degree of parallelism和max server memory (MB)。<br />Fill Factor(%): <br />这是一个用于调优数据存储和性能的server_side参数，当创建或者重建索引时，该值可以确定每个叶级页上要填充数据的空间百分比，以保留一些剩余空间作为以后扩展索引的可用空间。<br />Max Degree of Parallism（MaxDOP）：<br />限制并行计划执行时所用的处理器数量，即限制语句的并行度。<br />Max Server Memory（MB）：<br />设置buffer pool获取的内存的上限。</p>
<h3>3. 资源等待或者阻塞情况</h3>
<p>两个环境中，语句执行过程中，需要对比，是否有等待和阻塞情况发生。<br />查看等待情况：
<pre><code>WITH [Waits] AS
    (SELECT
        [wait_type],
        [wait_time_ms] / 1000.0 AS [WaitS],
        ([wait_time_ms] - [signal_wait_time_ms]) / 1000.0 AS [ResourceS],
        [signal_wait_time_ms] / 1000.0 AS [SignalS],
        [waiting_tasks_count] AS [WaitCount],
       100.0 * [wait_time_ms] / SUM ([wait_time_ms]) OVER() AS [Percentage],
        ROW_NUMBER() OVER(ORDER BY [wait_time_ms] DESC) AS [RowNum]
    FROM sys.dm_os_wait_stats
    WHERE [wait_type] NOT IN (
        N'BROKER_EVENTHANDLER', N'BROKER_RECEIVE_WAITFOR',
        N'BROKER_TASK_STOP', N'BROKER_TO_FLUSH',
        N'BROKER_TRANSMITTER', N'CHECKPOINT_QUEUE',
        N'CHKPT', N'CLR_AUTO_EVENT',
        N'CLR_MANUAL_EVENT', N'CLR_SEMAPHORE',
  -- Maybe uncomment these four if you have mirroring issues
        N'DBMIRROR_DBM_EVENT', N'DBMIRROR_EVENTS_QUEUE',
        N'DBMIRROR_WORKER_QUEUE', N'DBMIRRORING_CMD',

        N'DIRTY_PAGE_POLL', N'DISPATCHER_QUEUE_SEMAPHORE',
        N'EXECSYNC', N'FSAGENT',
        N'FT_IFTS_SCHEDULER_IDLE_WAIT', N'FT_IFTSHC_MUTEX',

        -- Maybe uncomment these six if you have AG issues
        N'HADR_CLUSAPI_CALL', N'HADR_FILESTREAM_IOMGR_IOCOMPLETION',
        N'HADR_LOGCAPTURE_WAIT', N'HADR_NOTIFICATION_DEQUEUE',
        N'HADR_TIMER_TASK', N'HADR_WORK_QUEUE',

  N'KSOURCE_WAKEUP', N'LAZYWRITER_SLEEP',
        N'LOGMGR_QUEUE', N'MEMORY_ALLOCATION_EXT',
        N'ONDEMAND_TASK_QUEUE',
        N'PREEMPTIVE_XE_GETTARGETSTATE',
        N'PWAIT_ALL_COMPONENTS_INITIALIZED',
        N'PWAIT_DIRECTLOGCONSUMER_GETNEXT',
        N'QDS_PERSIST_TASK_MAIN_LOOP_SLEEP', N'QDS_ASYNC_QUEUE',
        N'QDS_CLEANUP_STALE_QUERIES_TASK_MAIN_LOOP_SLEEP',
        N'QDS_SHUTDOWN_QUEUE', N'REDO_THREAD_PENDING_WORK',
        N'REQUEST_FOR_DEADLOCK_SEARCH', N'RESOURCE_QUEUE',
        N'SERVER_IDLE_CHECK', N'SLEEP_BPOOL_FLUSH',
        N'SLEEP_DBSTARTUP', N'SLEEP_DCOMSTARTUP',
        N'SLEEP_MASTERDBREADY', N'SLEEP_MASTERMDREADY',
        N'SLEEP_MASTERUPGRADED', N'SLEEP_MSDBSTARTUP',
        N'SLEEP_SYSTEMTASK', N'SLEEP_TASK',
        N'SLEEP_TEMPDBSTARTUP', N'SNI_HTTP_ACCEPT',
        N'SP_SERVER_DIAGNOSTICS_SLEEP', N'SQLTRACE_BUFFER_FLUSH',
        N'SQLTRACE_INCREMENTAL_FLUSH_SLEEP',
  N'SQLTRACE_WAIT_ENTRIES', N'WAIT_FOR_RESULTS',
        N'WAITFOR', N'WAITFOR_TASKSHUTDOWN',
        N'WAIT_XTP_RECOVERY',
        N'WAIT_XTP_HOST_WAIT', N'WAIT_XTP_OFFLINE_CKPT_NEW_LOG',
        N'WAIT_XTP_CKPT_CLOSE', N'XE_DISPATCHER_JOIN',
        N'XE_DISPATCHER_WAIT', N'XE_TIMER_EVENT')
    AND [waiting_tasks_count] &gt; 0
    )
SELECT
   MAX ([W1].[wait_type]) AS [WaitType],
    CAST (MAX ([W1].[WaitS]) AS DECIMAL (16,2)) AS [Wait_S],
    CAST (MAX ([W1].[ResourceS]) AS DECIMAL (16,2)) AS [Resource_S],
    CAST (MAX ([W1].[SignalS]) AS DECIMAL (16,2)) AS [Signal_S],
    MAX ([W1].[WaitCount]) AS [WaitCount],
    CAST (MAX ([W1].[Percentage]) AS DECIMAL (5,2)) AS [Percentage],
    CAST ((MAX ([W1].[WaitS]) / MAX ([W1].[WaitCount])) AS DECIMAL (16,4)) AS [AvgWait_S],
    CAST ((MAX ([W1].[ResourceS]) / MAX ([W1].[WaitCount])) AS DECIMAL (16,4)) AS [AvgRes_S],
    CAST ((MAX ([W1].[SignalS]) / MAX ([W1].[WaitCount])) AS DECIMAL (16,4)) AS [AvgSig_S],
    CAST ('https://www.sqlskills.com/help/waits/' + MAX ([W1].[wait_type]) as XML) AS [Help/Info URL]
FROM [Waits] AS [W1]

INNER JOIN [Waits] AS [W2]
    ON [W2].[RowNum] &lt;= [W1].[RowNum]
GROUP BY [W1].[RowNum]
HAVING SUM ([W2].[Percentage]) - MAX( [W1].[Percentage] ) &lt; 95; -- percentage threshold
GO</code></pre>
<p> 查看阻塞情况，参考RDS for SQL Server 阻塞问题处理方法。</p>
<h3>4. 两个环境中索引碎片率和统计信息是否一致。</h3>
<p>检查索引碎片率语句如下：
<pre><code>SELECT dbschemas.[name] as 'Schema',
dbtables.[name] as 'Table',
dbindexes.[name] as 'Index',
indexstats.avg_fragmentation_in_percent,
indexstats.page_count
FROM sys.dm_db_index_physical_stats (DB_ID(), NULL, NULL, NULL, NULL) AS indexstats
INNER JOIN sys.tables dbtables on dbtables.[object_id] = indexstats.[object_id]
INNER JOIN sys.schemas dbschemas on dbtables.[schema_id] = dbschemas.[schema_id]
INNER JOIN sys.indexes AS dbindexes ON dbindexes.[object_id] = indexstats.[object_id]
AND indexstats.index_id = dbindexes.index_id
WHERE indexstats.database_id = DB_ID()
ORDER BY indexstats.avg_fragmentation_in_percent desc</code></pre>
<p>索引碎片率大，影响查询的速度。如果索引碎片率在5%-30#之间，推荐重组索引；如果碎片率大于30%，推荐重建索引。</p>
<p>检查统计信息语句如下：</p>
<pre><code>SELECT t.name TableName, s.[name] StatName, STATS_DATE(t.object_id,s.[stats_id]) LastUpdated FROM sys.[stats] AS s JOIN sys.[tables] AS t ON [s].[object_id] = [t].[object_id] WHERE t.type = 'u'</code></pre>
<p>如果发现RDS中统计信息比自建库要老旧，可以手动更新下统计信息。 防止由于统计信息老旧，造成SQL  Server生成不准确的执行计划，降低执行效率。</p>
<h3>5. 高可用性架构</h3>
<p>RDS作为一个公共的关系数据库服务，首要是保证稳定高可用，高安全，保证用户使用的是既安全又稳定的服务。然后才是高性能。<br />RDS SQL Server为了保证主备数据的一致性，采用的是High Safety同步模式，相对于High Performance 模式，性能有所牺牲，但是增强了高可用性，保护了数据。 <br />同时， RDS 还提供多可用区主备实例，双节点在不同机房，更进一步保证了高可用性和安全性。</p>
<p><strong>问题排查：</strong><br />1. RDS实例的内存配置比本地高；<br />2. 网络延迟不大；<br />3. RDS的MAXDOP值是2，而ECS自建实例是默认值，即并行语句可以申请尽可能多的并行线程。<br />通过执行计划看出，RDS中查询语句的并行度是2，而自建库中查询语句的并行度是8，RDS中执行速度自然没有自建库快。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYXRhMi1pbWcuY24taGFuZ3pob3UuaW1nLXB1Yi5hbGl5dW4taW5jLmNvbS9hNWVjZGU0NzE0Nzk1ZmE3M2Y1MjNkMGZjNjkyNWZjNi5wbmc=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYXRhMi1pbWcuY24taGFuZ3pob3UuaW1nLXB1Yi5hbGl5dW4taW5jLmNvbS9mMTgzZGQ5NmEzNzI5ZTNmMThiODM3OWIwZjY2MjEyZi5wbmc=.jpg"><br /><strong>解决方案：</strong><br />1. 上述我们分析到，RDS的配置实际比自建库高，那么可以在RDS 实例控制台的参数设置中，增加max degree of parallelism值来提升并行度。<br />2. 通过执行计划，还发现用户表中有Missing Index。 在RDS添加了Missing Index后，查询性能有大幅度提升，即使并行度为2，也可以在5s执行完毕。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-17 05:46:55</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/rds/" title="RDS">RDS</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e7%b4%a2%e5%bc%95/" title="索引">索引</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/server/" title="server">server</a>, <a href="https://www.iamivan.net/tag/%e9%98%bf%e9%87%8c%e6%8a%80%e6%9c%af%e5%8d%8f%e4%bc%9a/" title="阿里技术协会">阿里技术协会</a>, <a href="https://www.iamivan.net/tag/%e9%ab%98%e5%8f%af%e7%94%a8/" title="高可用">高可用</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd%e6%b5%8b%e8%af%95/" title="性能测试">性能测试</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>性能测试：自建数据库与RDS性能对比SQL Server案例排查分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW2JXXb.html" rel="bookmark">《数据库基础及实践技术&mdash;&mdash;SQL Server 2008》一3&period;2　创建数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.2 创建数据库 利用SQL Server Management Studio(SSMS)工具,可以用图形化的方法创建数据库,也可以通过Transact-SQL语句创建数据库.下面分别介绍这两种方法. 3.2.1 用图形化方法创建数据库 在SSMS工具中用图形化方法创建数据库的步骤为: 1)启动SSMS,并以数据库管理员身份连接到SQL Server数据库服务器的一个实例上. 2)在SSMS的&quot;对象资源管理器&quot;中,在SQL Server实例下的&quot;数据库&quot;节点上右击			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZER3ap.html" rel="bookmark">《数据库基础及实践技术&mdash;&mdash;SQL Server 2008》一3&period;1　SQL Server数据库概述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.1 SQL Server数据库概述 SQL Server 2008中的数据库由包含数据的表集合以及其他对象(如视图.索引.存储过程等)组成,目的是为执行与数据有关的活动提供支持.SQL Server支持在一个实例中创建多个数据库,每个数据库在物理和逻辑上都是独立的,相互之间没有影响.每个数据库存储相关的数据.例如,可以用一个数据库存储商品及销售信息,用另一个数据库存储人事信息. 从数据库的应用和管理角度来看,SQL Server将数据库分为两大类:系统数据库和用户数据库.系统数据库是SQL			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5ZAKmz.html" rel="bookmark">《数据库基础及实践技术&mdash;&mdash;SQL Server 2008》一3&period;4　修改数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.4 修改数据库 创建完数据库后,用户在使用过程中可以根据需要对数据库的定义进行修改.修改数据库的操作主要包括如下几项: 扩大数据库空间. 缩小数据库空间. 添加和删除数据库文件. 创建文件组. 更改数据库所有者. 3.4.1 扩大数据库空间 如果在创建数据库时没有设置自动增长方式,则数据库在使用一段时间后可能会出现数据库空间不足的情况,这些空间包括数据空间和日志空间.如果数据空间不够,则意味着不能再向数据库中插入数据:如果日志空间不够,则意味着不能再对数据库数据进行任何修改操作,因为对数据的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vbQg70p.html" rel="bookmark">JSP数据库操作例程 - 存储过程 - JDBC-ODBC - SQL Server - 1&period;1版本</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js|odbc|server|存储过程|数据|数据库 &lt;%--作者:何志强[hhzqq@21cn.com]日期:2000-08-04 2000-08-16版本:1.1功能:JSP数据库操作例程 - 存储过程 - JDBC-ODBC - SQL Server SQL Server的存储过程如下:    create procedure sp_jsptest       @yourname  varchar(50),       @myname varchar(50) output    as   			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRv5Rp.html" rel="bookmark">《数据库基础及实践技术&mdash;&mdash;SQL Server 2008》一3&period;6　分离和附加数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.6 分离和附加数据库 利用分离和附加数据库的操作可以实现将数据库从一台计算机移动到另一台计算机,或者从一个实例移动到另一个实例的目的. 数据库被分离后,其所包含的数据文件和日志文件不再受数据库管理系统的管理,因此,用户可以复制或剪切该数据库的全部文件,然后将它们放置到另一台计算机上,或者本计算机的其他位置上.然后,通过附加的方法可以将数据库恢复到同一台数据库服务器上,或者附加到其他数据库服务器上. 如果要将数据库移动或复制到同一台服务器的不同SQL Server实例中,或者要移动数据库的数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQL5y0z.html" rel="bookmark">迁移本地SQL Server数据库到Windows Azure的SQL Server中</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Windows http://www.aliyun.com/zixun/aggregation/13357.html&quot;&gt;Azure现在提供了IaaS的运行模式,可以直接跑windows的虚机和安装SQL Server数据库.这也是目前在云中数据库最佳的应用方式了.但是怎么样把你在本地SQL Server数据库到Windows Azure的SQL Server上面呢,我原来以为非常简单,但是试了一下还是碰到了很多问题.最后虽然成功,觉得还是有必要和大家分享一下具体的做法,下面是主要的步骤概括			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze6rmVb.html" rel="bookmark">《数据库基础及实践技术&mdash;&mdash;SQL Server 2008》一2&period;5　SQL Server Management Studio工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.5 SQL Server Management Studio工具 SQL Server Management Studio是SQL Server 2008中最重要的管理工具之一,使用这个工具既可以用图形化的方法,也可以通过编写SQL语句来实现对数据库的操作. SQL Server Management Studio是一个集成环境,用于访问.配置和管理所有的SQL Server组件,它组合了大量的图形工具和丰富的脚本编辑器,使技术水平不同的开发和管理人员都可以通过这个工具访问和管理SQL Se			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGADJvM.html" rel="bookmark">一个字节造成的巨大性能差异&mdash;&mdash;SQL Server存储结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天同事问了我一个SQL的问题,关于SQL Server内部存储结构的,我觉得挺有意思,所以写下这篇博客讨论并归纳了一下.问题是这样的: 首先我们创建两张表,一张表的列长度是4039字节,另一张表的长度是4040字节,他们就只有一个字节的差距,比如以下创建表的SQL: CREATE TABLE tb4039(c1 INT IDENTITY,c2 char(4035) not null)CREATE TABLE tb4040(c1 INT IDENTITY,c2 char(4036) not nu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQjJ0wM.html" rel="bookmark">《数据库基础及实践技术&mdash;&mdash;SQL Server 2008》一1&period;2　数据库系统与数据库管理系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.2 数据库系统与数据库管理系统 本节介绍数据库系统的组成以及数据库管理系统的功能. 1.2.1 数据库系统的组成 数据库管理系统是一个系统软件,如SQL Server.Oracle.DB2等都是著名的数据库管理系统软件,但在有了数据库管理系统这个软件之后,并不意味着已经具有了用数据库管理系统管理数据的优点,必须在这个软件基础之上进行一些必要的工作,以把数据库管理系统提供的功能发挥出来.首先应该利用这个系统存放用户自己的数据,让数据库管理系统帮助我们把这些数据管理起来,其次还应有对这些数据进行			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpd6jdb.html" rel="bookmark" class="title">Android使用Activity用作弹出式对话框Dialog</a>
					<div>
						转载请表明出处:http://blog.csdn.net/lmj623565791/article/details/23116115 Android中可用于实现对话框的有Dialog,PopupWin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zem78z.html" rel="bookmark" class="title">CSS网页制作实例&colon;网页顶部绝对定位</a>
					<div>
						文章简介:top绝对定位. &lt;style&gt;body{margin:0;padding:0;height:1500px;}.top{width:100%;height:30px;backgr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXkgQM.html" rel="bookmark" class="title">从Hibernate2到3移植的两点初体验</a>
					<div>
						H3提供了很多令人兴奋的特性,从RC1提供download开始便在机器上创建了新的H3test project,由于时间问题,H3的E文doc也只看到第五章节(都是打印A4纸阅读的,饭前厕中枕边 苦~ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAqGQM.html" rel="bookmark" class="title">Oracle 9i索引</a>
					<div>
						  索引是若干数据行的关键字的列表,查询数据时,通过索引中的关键字可以快速定位到要访问的记录所在的数据块,从而大大减少读取数据块的I/O次数,因此可以显著提高性能. 索引的原理     下面通过查询数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6V0AM.html" rel="bookmark" class="title">语音上传（二）</a>
					<div>
						上传 表 sound 字段 id numeric 9 (自增) wav image 16 wavinfo varchar 50 wavsize numeric save.asp '将声音文件写入数据库 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPq8Az.html" rel="bookmark" class="title">GOOGLE忽略TITLE是针对百度的</a>
					<div>
						看了Google 开始忽略标题标签(title)的设定也许我们会联想到:难道google的这一举动主要是针对百度的? Google曾多次表明自己的产品在SEO方面是欠缺的.每个SEOER都应该知道,百 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElWr9z.html" rel="bookmark" class="title">windows下如何彻底删除MySQL</a>
					<div>
						卸载mysql其实也是一门艺术 1)控制面板里卸载 2)如果你的操作系统用户名是Administrator则删除 C:\Documents and Settings\Administrator\App ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE5W4b.html" rel="bookmark" class="title">利用HTML实现限制ip的投票网站作弊方案</a>
					<div>
						  HTML5 对限制ip的投票网站作弊方案,这个方法利用了投票网站监测远程ip的一些漏洞来实现,并没有真正的伪造ip地址,http是建立的tcp之上的第七层,是不可能伪造真实ip地址的最近朋友需要一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3kl6M.html" rel="bookmark" class="title">ios8&period;3系统定位不起作用</a>
					<div>
						问题描述 ios8.3系统定位不起作用 在8以下的系统能够定位成功,在8以上就不成功了,请问应该怎么改 解决方案 因为从8开始需要询问用户是否开启定位功能?网上搜下 解决方案二: 在调用 [self. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3j6ZM.html" rel="bookmark" class="title">MySQL &CenterDot;  引擎特性 &CenterDot;  DROP TABLE之binlog解析</a>
					<div>
						Drop Table的特殊之处 Drop Table乍一看,与其它DDL 也没什么区别,但当你深入去研究它的时候,发现还是有很多不同.最明显的地方就是DropTable后面可以紧跟多个表,并且可以是不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZLVkb.html" rel="bookmark" class="title">vim 环境写 markdown 的插件推荐</a>
					<div>
						vim 环境写 markdown 的插件推荐 本文将介绍在vim环境写markdown文档或者博文的一些好用插件 markdown语法高亮及识别 博主使用vim-markdown做语法高亮.安装方法很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWL31p.html" rel="bookmark" class="title">如何快速理解设计模式？</a>
					<div>
						问题描述 如何快速理解设计模式? 设计模式那么多,要怎么快速理解呢?又要在什么情况下使用.求大神指教. 解决方案 设计模式快速理解不了,这个东西需要不断的琢磨,没有一定的开发经验想快速理解也只能是理解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXadxz.html" rel="bookmark" class="title">spawn ssh</a>
					<div>
						#! /usr/bin/expect set ip [lindex $argv 0]; set username [lindex $argv 1]; set password [lindex $arg ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRK2rp.html" rel="bookmark" class="title">jQuery中removeData&lpar;&rpar;方法用法实例&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery中removeData()方法用法.分享给大家供大家参考.具体实现方法如下: 此方法可以移除匹配元素上指定的数据. removeData()方法与data()方法的作用相反. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrqdqjb.html" rel="bookmark" class="title">Android学习Scroller&lpar;二&rpar;&mdash;&mdash;ViewGroup调用scrollTo&lpar;&rpar;</a>
					<div>
						PS: 该篇博客已经deprecated,不再维护,详情请参见  站在源码的肩膀上全解Scroller工作机制  http://blog.csdn.net/lfdfhl/article/details ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12v13p.html" rel="bookmark" class="title">JavaScript arguments对象全面介绍</a>
					<div>
						1. 什么是 arguments MDN 上解释: arguments 是一个类数组对象.代表传给一个function的参数列表. 我们先用一个例子直观了解下 JavaScript 中的 argume ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnANaM.html" rel="bookmark" class="title">&period;net的对称加密在PHP里怎么解密</a>
					<div>
						问题描述 //获取或设置对称算法的机密密钥.privatebyte[]DESKeyNUM=newbyte[]{数组};//获取或设置对称算法的初始化向量.privatebyte[]DESIVNUM=n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M606YOz.html" rel="bookmark" class="title">cxf自定义拦截器怎么获取到传入参数值</a>
					<div>
						问题描述 cxf自定义拦截器怎么获取到传入参数值 cxf自定义拦截器怎么获取传入参数值 或者怎么 把 Object obj = message.getContent(List.class).get(0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQj8yQM.html" rel="bookmark" class="title">wpf 中如何实现combobox 下拉效果，下拉的选择面板中一行有多个选项</a>
					<div>
						问题描述 本人初次接触Wpf对wpf不太熟.请问一下如图中类似combobox有着,但是选择面板里面却有多个选项横着排列的效果在wpf中如何实现啊,有现成的控件么,还是要借助第三方控件呀,麻烦懂的,有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAERkeM.html" rel="bookmark" class="title">China Unicom and Chunghwa Telecom work together&amp;amp&semi;nb</a>
					<div>
						China Unicom and Chunghwa Telecom are planning to work together on iPhone platform. Incidentally, bo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJ7rvp.html" rel="bookmark" class="title">C&num; app&period;config</a>
					<div>
						问题描述 app.config中可以写一些参数么?不运行程序,只修改app.config,就能按照新的参数执行程序?是只能写string类型的么? 解决方案 解决方案二:可以写section,例如ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeleZM.html" rel="bookmark" class="title">《网站分析师实战指南》一导读</a>
					<div>
						前 言 网站分析师实战指南 伟大的市场决策源于高质量的数据分析. --约翰·斯卡利 这个惊世骇俗的论断是前百事公司总裁.苹果公司CEO约翰·斯卡利在1985年提出的,他是一位像史蒂夫·乔布斯一样的幻想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRlkZp.html" rel="bookmark" class="title">吴恩达成立1&period;5亿美元基金，专注AI投资</a>
					<div>
						上周,吴恩达宣布了一系列深度学习的课程,这也是他deeplearning.ai项目的一个开始.雷锋网消息,在美国时间15日晚,外媒TC报道称他又有新动作了,即成立一个1.5亿美元规模的风险投资基金AI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlJ6Zp.html" rel="bookmark" class="title">android使用service和activity获取屏幕尺寸的方法&lowbar;Android</a>
					<div>
						本文实例讲述了android使用service和activity获取屏幕尺寸的方法.分享给大家供大家参考.具体实现方法如下: 1. activity: DisplayMetrics dm = new  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1VnKb.html" rel="bookmark" class="title">php生成图片验证码&lowbar;php技巧</a>
					<div>
						先给看下 大致的效果 那么接下来的就直接贴代码吧 &lt;?php $image = imagecreatetruecolor(100, 30); //创建画布 $imagecolor = image ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1D22Kb.html" rel="bookmark" class="title">高手请进 淘宝登录管理</a>
					<div>
						问题描述 我想用C#写个程序来操作淘宝登录,不管是C/S的还是B/S的,最好是可以自动登录的,比如说把淘宝的页面潜入到我们的程序中,在我们的程序中来操作淘宝的DOM节点(点个按钮把帐号和密码自动填到淘 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK05xLM.html" rel="bookmark" class="title">百度技术沙龙第十七期：论剑富客户端时代的JavaScript框架</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 目前,几乎所有网站都在使用JavaScript和Ajax技术,好的框架不仅可以帮助设计师和开发人员把精力集中在关键业务上,而且可以避免重复开发,打造优秀 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWYr5p.html" rel="bookmark" class="title">巴黎恐怖袭击震惊全球 网络战场硝烟从未停止</a>
					<div>
						法国当地时间11月13日晚上,巴黎市中心一餐馆和法兰西球场附近等多处发生枪击和爆炸事件,目前已造成100多人死伤,伤亡人数在不断上升. 法国总统奥朗德称此次袭击系&quot;史无前例的恐怖袭击&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAWwVp.html" rel="bookmark" class="title">《海外社交媒体营销》一一2&period;1　社交媒体与其他媒体的关系</a>
					<div>
						2.1 社交媒体与其他媒体的关系 大部分公司在从事社交媒体营销的时候,还会同时使用其他媒体平台开展营销活动,例如,搜索引擎.公司官网.博客.视频分享网站和线下媒体等.在开拓一个新市场的时候,你可能会面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx2QE0z.html" rel="bookmark" class="title">Python树莓派编程3&period;4&period;3　函数</a>
					<div>
						3.4.3 函数 函数可以让程序员编写的代码重复使用.它能大大提高工作效率.通常,如果你发现代码中某些功能需要执行很多次,这个功能很有可能需要改写为函数. 假设你编写了一个简单的程序用来计算矩形的面积 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
